OGRE: Ogre::Node Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::Node Class Referenceabstract
Core » Scene

Class representing a general-purpose node an articulated scene graph. More...

`#include <OgreNode.h>`

Inheritance diagram for Ogre::Node:
[legend]

## Classes
class | Listener
| Listener which gets called back on Node events. More...

## Public Types
typedef VectorIterator< ChildNodeMap > | ChildNodeIterator
typedef std::vector< Node * > | ChildNodeMap
typedef ConstVectorIterator< ChildNodeMap > | ConstChildNodeIterator
enum | TransformSpace { TS_LOCAL , TS_PARENT , TS_WORLD }
| Enumeration denoting the spaces which a transform can be relative to. More...

## Public Member Functions
| Node (const String &name="")
| Constructor, should only be called by parent, not directly.
virtual | ~Node ()
const Quaternion & | _getDerivedOrientation (void) const
| Gets the orientation of the node as derived from all parents.
const Vector3 & | _getDerivedPosition (void) const
| Gets the position of the node as derived from all parents.
const Vector3 & | _getDerivedScale (void) const
| Gets the scaling factor of the node as derived from all parents.
const Affine3 & | _getFullTransform (void) const
| Gets the full transformation matrix for this node.
void | _setDerivedOrientation (const Quaternion &q)
| Sets the final world orientation of the node directly.
void | _setDerivedPosition (const Vector3 &pos)
| Sets the final world position of the node directly.
virtual void | _update (bool updateChildren, bool parentHasChanged)
| Internal method to update the Node.
void | addChild (Node *child)
| Adds a (precreated) child scene node to this node.
void | cancelUpdate (Node *child)
| Called by children to notify their parent that they no longer need an update.
Vector3 | convertLocalToWorldDirection (const Vector3 &localDir, bool useScale)
| Gets the world direction of a point in the node local space useful for simple transforms that don't require a child node.
Quaternion | convertLocalToWorldOrientation (const Quaternion &localOrientation)
| Gets the world orientation of an orientation in the node local space useful for simple transforms that don't require a child node.
Vector3 | convertLocalToWorldPosition (const Vector3 &localPos)
| Gets the world position of a point in the node local space useful for simple transforms that don't require a child node.
Vector3 | convertWorldToLocalDirection (const Vector3 &worldDir, bool useScale)
| Gets the local direction, relative to this node, of the given world-space direction.
Quaternion | convertWorldToLocalOrientation (const Quaternion &worldOrientation)
| Gets the local orientation, relative to this node, of the given world-space orientation.
Vector3 | convertWorldToLocalPosition (const Vector3 &worldPos)
| Gets the local position, relative to this node, of the given world-space position.
virtual Node * | createChild (const String &name, const Vector3 &translate=Vector3::ZERO, const Quaternion &rotate=Quaternion::IDENTITY)
| Creates a new named Node as a child of this node.
virtual Node * | createChild (const Vector3 &translate=Vector3::ZERO, const Quaternion &rotate=Quaternion::IDENTITY)
| Creates an unnamed new Node as a child of this node.
Node * | getChild (const String &name) const
| Gets a pointer to a named child node.
Node * | getChild (unsigned short index) const
| Gets a pointer to a child node.
ChildNodeIterator | getChildIterator (void)
ConstChildNodeIterator | getChildIterator (void) const
const ChildNodeMap & | getChildren () const
| List of sub-nodes of this Node.
bool | getInheritOrientation (void) const
| Returns true if this node is affected by orientation applied to the parent node.
bool | getInheritScale (void) const
| Returns true if this node is affected by scaling factors applied to the parent node.
const Quaternion & | getInitialOrientation (void) const
| Gets the initial orientation of this node, see setInitialState for more info.
const Vector3 & | getInitialPosition (void) const
| Gets the initial position of this node, see setInitialState for more info.
const Vector3 & | getInitialScale (void) const
| Gets the initial position of this node, see setInitialState for more info.
Listener * | getListener (void) const
| Gets the current listener for this Node.
Matrix3 | getLocalAxes (void) const
| Gets a matrix whose columns are the local axes based on the nodes orientation relative to it's parent.
const String & | getName (void) const
| Returns the name of the node.
const Quaternion & | getOrientation () const
| Returns a quaternion representing the nodes orientation.
Node * | getParent (void) const
| Gets this node's parent (NULL if this is the root).
const Vector3 & | getPosition (void) const
| Gets the position of the node relative to it's parent.
const Vector3 & | getScale (void) const
| Gets the scaling factor of this node.
Real | getSquaredViewDepth (const Camera *cam) const
| Helper function, get the squared view depth.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void | needUpdate (bool forceParentUpdate=false)
| To be called in the event of transform changes to this node that require it's recalculation.
uint16 | numChildren (void) const
| Reports the number of child nodes under this one.
virtual void | pitch (const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around the X-axis.
virtual void | removeAllChildren (void)
| Removes all child Nodes attached to this node.
virtual Node * | removeChild (const String &name)
| Drops the named child from this node.
virtual Node * | removeChild (Node *child)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual Node * | removeChild (unsigned short index)
| Drops the specified child from this node.
void | requestUpdate (Node *child, bool forceParentUpdate=false)
| Called by children to notify their parent that they need an update.
void | resetOrientation (void)
| Resets the nodes orientation (local axes as world axes, no rotation).
void | resetToInitialState (void)
| Resets the position / orientation / scale of this node to it's initial state, see setInitialState for more info.
virtual void | roll (const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around the Z-axis.
void | rotate (const Quaternion &q, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around an arbitrary axis using a Quarternion.
void | rotate (const Vector3 &axis, const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around an arbitrary axis.
void | scale (const Vector3 &scale)
| Scales the node, combining it's current scale with the passed in scaling factor.
void | scale (Real x, Real y, Real z)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setInheritOrientation (bool inherit)
| Tells the node whether it should inherit orientation from it's parent node.
void | setInheritScale (bool inherit)
| Tells the node whether it should inherit scaling factors from it's parent node.
void | setInitialState (void)
| Sets the current transform of this node to be the 'initial state' ie that position / orientation / scale to be used as a basis for delta values used in keyframe animation.
void | setListener (Listener *listener)
| Sets a listener for this Node.
void | setOrientation (const Quaternion &q)
| Sets the orientation of this node via a quaternion.
void | setOrientation (Real w, Real x, Real y, Real z)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setPosition (const Vector3 &pos)
| Sets the position of the node relative to it's parent.
void | setPosition (Real x, Real y, Real z)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setScale (const Vector3 &scale)
| Sets the scaling factor applied to this node.
void | setScale (Real x, Real y, Real z)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setUserAny (const Any &anything)
void | translate (const Matrix3 &axes, const Vector3 &move, TransformSpace relativeTo=TS_PARENT)
| Moves the node along arbitrary axes.
void | translate (const Matrix3 &axes, Real x, Real y, Real z, TransformSpace relativeTo=TS_PARENT)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | translate (const Vector3 &d, TransformSpace relativeTo=TS_PARENT)
| Moves the node along the Cartesian axes.
void | translate (Real x, Real y, Real z, TransformSpace relativeTo=TS_PARENT)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void | yaw (const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around the Y-axis.

## Static Public Member Functions
static void | processQueuedUpdates (void)
| Process queued 'needUpdate' calls.
static void | queueNeedUpdate (Node *n)
| Queue a 'needUpdate' call to a node safely.

## Detailed Description

Class representing a general-purpose node an articulated scene graph.

A node in the scene graph is a node in a structured tree. A node contains information about the transformation which will apply to it and all of it's children. Child nodes can have transforms of their own, which are combined with their parent's transformations.

  This is an abstract class - concrete classes are based on this for specific purposes, e.g. SceneNode, Bone

## Member Typedef Documentation

## ◆ ChildNodeMap

typedef std::vector<Node*> Ogre::Node::ChildNodeMap

## ◆ ChildNodeIterator

typedef VectorIterator<ChildNodeMap> Ogre::Node::ChildNodeIterator

## ◆ ConstChildNodeIterator

typedef ConstVectorIterator<ChildNodeMap> Ogre::Node::ConstChildNodeIterator

## Member Enumeration Documentation

## ◆ TransformSpace

enum Ogre::Node::TransformSpace

Enumeration denoting the spaces which a transform can be relative to.

Enumerator
TS_LOCAL | Transform is relative to the local space.
TS_PARENT | Transform is relative to the space of the parent node.
TS_WORLD | Transform is relative to world space.

## Constructor & Destructor Documentation

## ◆ Node()

Ogre::Node::Node | ( | const String & | name = "" | ) |

Constructor, should only be called by parent, not directly.

Referenced by addChild(), cancelUpdate(), createChild(), createChild(), getChild(), getChild(), getParent(), Ogre::Bone::needUpdate(), Ogre::Node::Listener::nodeAttached(), Ogre::Node::Listener::nodeDestroyed(), Ogre::Node::Listener::nodeDetached(), Ogre::Node::Listener::nodeUpdated(), queueNeedUpdate(), removeChild(), removeChild(), removeChild(), and requestUpdate().

## ◆ ~Node()

virtual Ogre::Node::~Node | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ getName()

const String & Ogre::Node::getName | ( | void |  | ) | const
| inline

Returns the name of the node.

## ◆ getParent()

Node * Ogre::Node::getParent | ( | void |  | ) | const
| inline

Gets this node's parent (NULL if this is the root).

References Node().

## ◆ getOrientation()

const Quaternion & Ogre::Node::getOrientation | ( |  | ) | const
| inline

Returns a quaternion representing the nodes orientation.

## ◆ setOrientation() [1/2]

void Ogre::Node::setOrientation | ( | const Quaternion & | q | ) |

Sets the orientation of this node via a quaternion.

Orientations, unlike other transforms, are not always inherited by child nodes. Whether or not orientations affect the orientation of the child nodes depends on the setInheritOrientation option of the child. In some cases you want a orientating of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative orientation based on the parent's orientation), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own orientation). The default is to inherit as with other transforms.

  Note that rotations are oriented around the node's origin.

## ◆ setOrientation() [2/2]

void Ogre::Node::setOrientation | ( | Real | w,
|  | Real | x,
|  | Real | y,
|  | Real | z )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ resetOrientation()

void Ogre::Node::resetOrientation | ( | void |  | ) |

Resets the nodes orientation (local axes as world axes, no rotation).

Orientations, unlike other transforms, are not always inherited by child nodes. Whether or not orientations affect the orientation of the child nodes depends on the setInheritOrientation option of the child. In some cases you want a orientating of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative orientation based on the parent's orientation), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own orientation). The default is to inherit as with other transforms.

  Note that rotations are oriented around the node's origin.

## ◆ setPosition() [1/2]

void Ogre::Node::setPosition | ( | const Vector3 & | pos | ) |

Sets the position of the node relative to it's parent.

## ◆ setPosition() [2/2]

void Ogre::Node::setPosition | ( | Real | x,
|  | Real | y,
|  | Real | z )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References setPosition().

Referenced by setPosition().

## ◆ getPosition()

const Vector3 & Ogre::Node::getPosition | ( | void |  | ) | const
| inline

Gets the position of the node relative to it's parent.

## ◆ setScale() [1/2]

void Ogre::Node::setScale | ( | const Vector3 & | scale | ) |

Sets the scaling factor applied to this node.

Scaling factors, unlike other transforms, are not always inherited by child nodes. Whether or not scalings affect the size of the child nodes depends on the setInheritScale option of the child. In some cases you want a scaling factor of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative size based on the parent's size), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own size). The default is to inherit as with other transforms.

  Note that like rotations, scalings are oriented around the node's origin.

References scale().

## ◆ setScale() [2/2]

void Ogre::Node::setScale | ( | Real | x,
|  | Real | y,
|  | Real | z )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References setScale().

Referenced by setScale().

## ◆ getScale()

const Vector3 & Ogre::Node::getScale | ( | void |  | ) | const
| inline

Gets the scaling factor of this node.

## ◆ setInheritOrientation()

void Ogre::Node::setInheritOrientation | ( | bool | inherit | ) |

Tells the node whether it should inherit orientation from it's parent node.

Orientations, unlike other transforms, are not always inherited by child nodes. Whether or not orientations affect the orientation of the child nodes depends on the setInheritOrientation option of the child. In some cases you want a orientating of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative orientation based on the parent's orientation), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own orientation). The default is to inherit as with other transforms.

Parameters

  inherit | If true, this node's orientation will be affected by its parent's orientation. If false, it will not be affected.

## ◆ getInheritOrientation()

bool Ogre::Node::getInheritOrientation | ( | void |  | ) | const
| inline

Returns true if this node is affected by orientation applied to the parent node.

Orientations, unlike other transforms, are not always inherited by child nodes. Whether or not orientations affect the orientation of the child nodes depends on the setInheritOrientation option of the child. In some cases you want a orientating of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative orientation based on the parent's orientation), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own orientation). The default is to inherit as with other transforms.

See setInheritOrientation for more info.

## ◆ setInheritScale()

void Ogre::Node::setInheritScale | ( | bool | inherit | ) |

Tells the node whether it should inherit scaling factors from it's parent node.

Scaling factors, unlike other transforms, are not always inherited by child nodes. Whether or not scalings affect the size of the child nodes depends on the setInheritScale option of the child. In some cases you want a scaling factor of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative size based on the parent's size), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own size). The default is to inherit as with other transforms.

Parameters

  inherit | If true, this node's scale will be affected by its parent's scale. If false, it will not be affected.

## ◆ getInheritScale()

bool Ogre::Node::getInheritScale | ( | void |  | ) | const
| inline

Returns true if this node is affected by scaling factors applied to the parent node.

See setInheritScale for more info.

## ◆ scale() [1/2]

void Ogre::Node::scale | ( | const Vector3 & | scale | ) |

Scales the node, combining it's current scale with the passed in scaling factor.

This method applies an extra scaling factor to the node's existing scale, (unlike setScale which overwrites it) combining it's current scale with the new one. E.g. calling this method twice with Vector3(2,2,2) would have the same effect as setScale(Vector3(4,4,4)) if the existing scale was 1.

  Note that like rotations, scalings are oriented around the node's origin.

References scale().

Referenced by scale(), and setScale().

## ◆ scale() [2/2]

void Ogre::Node::scale | ( | Real | x,
|  | Real | y,
|  | Real | z )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ translate() [1/4]

void Ogre::Node::translate | ( | const Vector3 & | d,
|  | TransformSpace | relativeTo = TS_PARENT )

Moves the node along the Cartesian axes.

  This method moves the node by the supplied vector along the world Cartesian axes, i.e. along world x,y,z

Parameters

  d | Vector with x,y,z values representing the translation.
  relativeTo | The space which this transform is relative to.

References TS_PARENT.

Referenced by Ogre::Bone::createChild(), createChild(), createChild(), Ogre::PCZSceneNode::createChildSceneNode(), Ogre::PCZSceneNode::createChildSceneNode(), Ogre::SceneNode::createChildSceneNode(), Ogre::SceneNode::createChildSceneNode(), translate(), translate(), and translate().

## ◆ translate() [2/4]

void Ogre::Node::translate | ( | Real | x,
|  | Real | y,
|  | Real | z,
|  | TransformSpace | relativeTo = TS_PARENT )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References translate(), and TS_PARENT.

## ◆ translate() [3/4]

void Ogre::Node::translate | ( | const Matrix3 & | axes,
|  | const Vector3 & | move,
|  | TransformSpace | relativeTo = TS_PARENT )
| inline

Moves the node along arbitrary axes.

This method translates the node by a vector which is relative to a custom set of axes.

Parameters

  axes | A 3x3 Matrix containing 3 column vectors each representing the axes X, Y and Z respectively. In this format the standard cartesian axes would be expressed as:
          1 0 0
          0 1 0
          0 0 1
  i.e. the identity matrix.
  move | Vector relative to the axes above.
  relativeTo | The space which this transform is relative to.

References translate(), and TS_PARENT.

## ◆ translate() [4/4]

void Ogre::Node::translate | ( | const Matrix3 & | axes,
|  | Real | x,
|  | Real | y,
|  | Real | z,
|  | TransformSpace | relativeTo = TS_PARENT )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References translate(), and TS_PARENT.

## ◆ roll()

virtual void Ogre::Node::roll | ( | const Radian & | angle,
|  | TransformSpace | relativeTo = TS_LOCAL )
| inlinevirtual

Rotate the node around the Z-axis.

References rotate(), and TS_LOCAL.

## ◆ pitch()

virtual void Ogre::Node::pitch | ( | const Radian & | angle,
|  | TransformSpace | relativeTo = TS_LOCAL )
| inlinevirtual

Rotate the node around the X-axis.

References rotate(), and TS_LOCAL.

## ◆ yaw()

virtual void Ogre::Node::yaw | ( | const Radian & | angle,
|  | TransformSpace | relativeTo = TS_LOCAL )
| inlinevirtual

Rotate the node around the Y-axis.

Reimplemented in Ogre::SceneNode.

References rotate(), and TS_LOCAL.

## ◆ rotate() [1/2]

void Ogre::Node::rotate | ( | const Vector3 & | axis,
|  | const Radian & | angle,
|  | TransformSpace | relativeTo = TS_LOCAL )
| inline

Rotate the node around an arbitrary axis.

References rotate(), and TS_LOCAL.

Referenced by Ogre::Bone::createChild(), createChild(), createChild(), Ogre::PCZSceneNode::createChildSceneNode(), Ogre::PCZSceneNode::createChildSceneNode(), Ogre::SceneNode::createChildSceneNode(), Ogre::SceneNode::createChildSceneNode(), pitch(), roll(), rotate(), and yaw().

## ◆ rotate() [2/2]

void Ogre::Node::rotate | ( | const Quaternion & | q,
|  | TransformSpace | relativeTo = TS_LOCAL )

Rotate the node around an arbitrary axis using a Quarternion.

References TS_LOCAL.

## ◆ getLocalAxes()

Matrix3 Ogre::Node::getLocalAxes | ( | void |  | ) | const

Gets a matrix whose columns are the local axes based on the nodes orientation relative to it's parent.

## ◆ createChild() [1/2]

virtual Node * Ogre::Node::createChild | ( | const Vector3 & | translate = Vector3::ZERO,
|  | const Quaternion & | rotate = Quaternion::IDENTITY )
| virtual

Creates an unnamed new Node as a child of this node.

Parameters

  translate | Initial translation offset of child relative to parent
  rotate | Initial rotation relative to parent

References Node(), Ogre::Quaternion::IDENTITY, rotate(), and translate().

Referenced by Ogre::Bone::~Bone().

## ◆ createChild() [2/2]

virtual Node * Ogre::Node::createChild | ( | const String & | name,
|  | const Vector3 & | translate = Vector3::ZERO,
|  | const Quaternion & | rotate = Quaternion::IDENTITY )
| virtual

Creates a new named Node as a child of this node.

This creates a child node with a given name, which allows you to look the node up from the parent which holds this collection of nodes.

Parameters

  name | Name of the Node to create
  translate | Initial translation offset of child relative to parent
  rotate | Initial rotation relative to parent

References Node(), Ogre::Quaternion::IDENTITY, rotate(), and translate().

## ◆ addChild()

void Ogre::Node::addChild | ( | Node * | child | ) |

Adds a (precreated) child scene node to this node.

If it is attached to another node, it must be detached first.

Parameters

  child | The Node which is to become a child node of this one

References Node().

## ◆ numChildren()

uint16 Ogre::Node::numChildren | ( | void |  | ) | const
| inline

Reports the number of child nodes under this one.

Deprecated
  use getChildren()

## ◆ getChild() [1/2]

Node * Ogre::Node::getChild | ( | unsigned short | index | ) | const

Gets a pointer to a child node.

There is an alternate getChild method which returns a named child.

Deprecated
  use getChildren()

References Node().

## ◆ getChild() [2/2]

Node * Ogre::Node::getChild | ( | const String & | name | ) | const

Gets a pointer to a named child node.

References Node().

## ◆ getChildIterator() [1/2]

ChildNodeIterator Ogre::Node::getChildIterator | ( | void |  | ) |

Deprecated
  use getChildren()

## ◆ getChildIterator() [2/2]

ConstChildNodeIterator Ogre::Node::getChildIterator | ( | void |  | ) | const

Deprecated
  use getChildren()

## ◆ getChildren()

const ChildNodeMap & Ogre::Node::getChildren | ( |  | ) | const
| inline

List of sub-nodes of this Node.

## ◆ removeChild() [1/3]

virtual Node * Ogre::Node::removeChild | ( | unsigned short | index | ) |
| virtual

Drops the specified child from this node.

Does not delete the node, just detaches it from this parent, potentially to be reattached elsewhere. There is also an alternate version which drops a named child from this node.

Reimplemented in Ogre::OctreeNode.

References Node().

## ◆ removeChild() [2/3]

virtual Node * Ogre::Node::removeChild | ( | Node * | child | ) |
| virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Reimplemented in Ogre::OctreeNode.

References Node().

## ◆ removeChild() [3/3]

virtual Node * Ogre::Node::removeChild | ( | const String & | name | ) |
| virtual

Drops the named child from this node.

Does not delete the node, just detaches it from this parent, potentially to be reattached elsewhere.

Reimplemented in Ogre::OctreeNode.

References Node().

## ◆ removeAllChildren()

virtual void Ogre::Node::removeAllChildren | ( | void |  | ) |
| virtual

Removes all child Nodes attached to this node.

Does not delete the nodes, just detaches them from this parent, potentially to be reattached elsewhere.

Reimplemented in Ogre::OctreeNode.

## ◆ _setDerivedPosition()

void Ogre::Node::_setDerivedPosition | ( | const Vector3 & | pos | ) |

Sets the final world position of the node directly.

It's advisable to use the local setPosition if possible

## ◆ _setDerivedOrientation()

void Ogre::Node::_setDerivedOrientation | ( | const Quaternion & | q | ) |

Sets the final world orientation of the node directly.

It's advisable to use the local setOrientation if possible, this simply does the conversion for you.

## ◆ _getDerivedOrientation()

const Quaternion & Ogre::Node::_getDerivedOrientation | ( | void |  | ) | const

Gets the orientation of the node as derived from all parents.

## ◆ _getDerivedPosition()

const Vector3 & Ogre::Node::_getDerivedPosition | ( | void |  | ) | const

Gets the position of the node as derived from all parents.

Referenced by Ogre::SceneManager::_populateLightList().

## ◆ _getDerivedScale()

const Vector3 & Ogre::Node::_getDerivedScale | ( | void |  | ) | const

Gets the scaling factor of the node as derived from all parents.

## ◆ _getFullTransform()

const Affine3 & Ogre::Node::_getFullTransform | ( | void |  | ) | const

Gets the full transformation matrix for this node.

This method returns the full transformation matrix for this node, including the effect of any parent node transformations, provided they have been updated using the Node::_update method. This should only be called by a SceneManager which knows the derived transforms have been updated before calling this method. Applications using Ogre should just use the relative transforms.

## ◆ _update()

virtual void Ogre::Node::_update | ( | bool | updateChildren,
|  | bool | parentHasChanged )
| virtual

Internal method to update the Node.

Note
  Updates this node and any relevant children to incorporate transforms etc. Don't call this yourself unless you are writing a SceneManager implementation.

Parameters

  updateChildren | If `true`, the update cascades down to all children. Specify false if you wish to update children separately, e.g. because of a more selective SceneManager implementation.
  parentHasChanged | This flag indicates that the parent transform has changed, so the child should retrieve the parent's transform and combine it with its own even if it hasn't changed itself.

Reimplemented in Ogre::BspSceneNode, Ogre::PCZSceneNode, and Ogre::SceneNode.

## ◆ setListener()

void Ogre::Node::setListener | ( | Listener * | listener | ) |
| inline

Sets a listener for this Node.

Note for size and performance reasons only one listener per node is allowed.

## ◆ getListener()

Listener * Ogre::Node::getListener | ( | void |  | ) | const
| inline

Gets the current listener for this Node.

## ◆ setInitialState()

void Ogre::Node::setInitialState | ( | void |  | ) |

Sets the current transform of this node to be the 'initial state' ie that position / orientation / scale to be used as a basis for delta values used in keyframe animation.

You never need to call this method unless you plan to animate this node. If you do plan to animate it, call this method once you've loaded the node with it's base state, ie the state on which all keyframes are based.

  If you never call this method, the initial state is the identity transform, ie do nothing.

## ◆ resetToInitialState()

void Ogre::Node::resetToInitialState | ( | void |  | ) |

Resets the position / orientation / scale of this node to it's initial state, see setInitialState for more info.

## ◆ getInitialPosition()

const Vector3 & Ogre::Node::getInitialPosition | ( | void |  | ) | const
| inline

Gets the initial position of this node, see setInitialState for more info.

Also resets the cumulative animation weight used for blending.

## ◆ convertWorldToLocalPosition()

Vector3 Ogre::Node::convertWorldToLocalPosition | ( | const Vector3 & | worldPos | ) |

Gets the local position, relative to this node, of the given world-space position.

## ◆ convertLocalToWorldPosition()

Vector3 Ogre::Node::convertLocalToWorldPosition | ( | const Vector3 & | localPos | ) |

Gets the world position of a point in the node local space useful for simple transforms that don't require a child node.

## ◆ convertWorldToLocalDirection()

Vector3 Ogre::Node::convertWorldToLocalDirection | ( | const Vector3 & | worldDir,
|  | bool | useScale )

Gets the local direction, relative to this node, of the given world-space direction.

## ◆ convertLocalToWorldDirection()

Vector3 Ogre::Node::convertLocalToWorldDirection | ( | const Vector3 & | localDir,
|  | bool | useScale )

Gets the world direction of a point in the node local space useful for simple transforms that don't require a child node.

## ◆ convertWorldToLocalOrientation()

Quaternion Ogre::Node::convertWorldToLocalOrientation | ( | const Quaternion & | worldOrientation | ) |

Gets the local orientation, relative to this node, of the given world-space orientation.

## ◆ convertLocalToWorldOrientation()

Quaternion Ogre::Node::convertLocalToWorldOrientation | ( | const Quaternion & | localOrientation | ) |

Gets the world orientation of an orientation in the node local space useful for simple transforms that don't require a child node.

## ◆ getInitialOrientation()

const Quaternion & Ogre::Node::getInitialOrientation | ( | void |  | ) | const
| inline

Gets the initial orientation of this node, see setInitialState for more info.

## ◆ getInitialScale()

const Vector3 & Ogre::Node::getInitialScale | ( | void |  | ) | const
| inline

Gets the initial position of this node, see setInitialState for more info.

## ◆ getSquaredViewDepth()

Real Ogre::Node::getSquaredViewDepth | ( | const Camera * | cam | ) | const

Helper function, get the squared view depth.

## ◆ needUpdate()

virtual void Ogre::Node::needUpdate | ( | bool | forceParentUpdate = false | ) |
| virtual

To be called in the event of transform changes to this node that require it's recalculation.

This not only tags the node state as being 'dirty', it also requests it's parent to know about it's dirtiness so it will get an update next time.

Parameters

  forceParentUpdate | Even if the node thinks it has already told it's parent, tell it anyway

Reimplemented in Ogre::Bone, and Ogre::TagPoint.

## ◆ requestUpdate()

void Ogre::Node::requestUpdate | ( | Node * | child,
|  | bool | forceParentUpdate = false )

Called by children to notify their parent that they need an update.

Parameters

  child | The child Node to be updated
  forceParentUpdate | Even if the node thinks it has already told it's parent, tell it anyway

References Node().

## ◆ cancelUpdate()

void Ogre::Node::cancelUpdate | ( | Node * | child | ) |

Called by children to notify their parent that they no longer need an update.

References Node().

## ◆ queueNeedUpdate()

void Ogre::Node::queueNeedUpdate | ( | Node * | n | ) |
| static

Queue a 'needUpdate' call to a node safely.

You can't call needUpdate() during the scene graph update, e.g. in response to a Node::Listener hook, because the graph is already being updated, and update flag changes cannot be made reliably in that context. Call this method if you need to queue a needUpdate call in this case.

References Node().

## ◆ processQueuedUpdates()

void Ogre::Node::processQueuedUpdates | ( | void |  | ) |
| static

Process queued 'needUpdate' calls.

## ◆ setUserAny()

void Ogre::Node::setUserAny | ( | const Any & | anything | ) |
| inline

Deprecated
  use UserObjectBindings::setUserAny via getUserObjectBindings() instead.

References getUserObjectBindings().

## ◆ getUserAny()

const Any & Ogre::Node::getUserAny | ( | void |  | ) | const
| inline

Deprecated
  use UserObjectBindings::getUserAny via getUserObjectBindings() instead.

References getUserObjectBindings().

## ◆ getUserObjectBindings() [1/2]

UserObjectBindings & Ogre::Node::getUserObjectBindings | ( |  | ) |
| inline

Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.

Referenced by getUserAny(), and setUserAny().

## ◆ getUserObjectBindings() [2/2]

const UserObjectBindings & Ogre::Node::getUserObjectBindings | ( |  | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

The documentation for this class was generated from the following file:

- OgreNode.h